function [outRect] = findLPRect(lpRegions)

minSkewDiff = 2*pi; skewRegion = 1; h = 0; dMinGlob=Inf; dMaxGlob = 0;

for i=1:length(lpRegions.regions),
    %plot(lpRegions.regions(i).area(:,2), -lpRegions.regions(i).area(:,1), '.'); hold on;
    xMin = lpRegions.regions(i).area(lpRegions.regions(i).convex.iMin(lpRegions.fiIndex),2);
    yMin = lpRegions.regions(i).area(lpRegions.regions(i).convex.iMin(lpRegions.fiIndex),1);
    xMax = lpRegions.regions(i).area(lpRegions.regions(i).convex.iMax(lpRegions.fiIndex),2);
    yMax = lpRegions.regions(i).area(lpRegions.regions(i).convex.iMax(lpRegions.fiIndex),1);
    dMin = lpRegions.regions(i).convex.dMin(lpRegions.fiIndex);
    dMax = lpRegions.regions(i).convex.dMax(lpRegions.fiIndex);
   % plot(xMin, -yMin,'ro');
    if dMin<dMinGlob,
        dMinGlob = dMin;
        xMinGlob = xMin; yMinGlob = yMin;
    end
    if dMax>dMaxGlob,
        dMaxGlob = dMax;
        xMaxGlob = xMax; yMaxGlob = yMax;
    end
    
%    if abs(lpRegions.skew - lpRegions.regions(i).skew)<minSkewDiff,
%        minSkewDiff = abs(lpRegions.skew-lpRegions.regions(i).skew);
%        skewRegion = i;
%    end
     h = h + lpRegions.regions(i).height;
%    h=max(h,lpRegions.regions(i).height);
   % plot(xMin, -yMin, 'o'); hold on; plot(xMax, -yMax, 'ro'); hold on;
end
% plot(xMinGlob, -yMinGlob, 'x'); hold on; plot(xMaxGlob, -yMaxGlob, 'rx');
h = h / i;
reserv = 0.8*h;
yreserv = 0.2*h;
[J I] = max([lpRegions.regions.height]);
r1 = lpRegions.regions(1); r2 = lpRegions.regions(length(lpRegions.regions)); rs = lpRegions.regions(I);
xLeft = min(r1.area(:,2)); xRight = max(r2.area(:,2));
vec1 = 1 * dist([rs.posX rs.posY],[r1.posX r1.posY]') * [cos(lpRegions.alpha) -sin(lpRegions.alpha)];
vec2 = 1 * dist([rs.posX rs.posY],[r2.posX r2.posY]') * [cos(lpRegions.alpha) -sin(lpRegions.alpha)]; 
if (norm(vec1)>norm(vec2)),
    drc = vec1;
else
    drc = vec2;
end
vec1 = drc * 0.5*h/norm(drc) + vec1;
vec2 = drc * 0.5*h/norm(drc) + vec2;
u(1) = rs.lowSkewPoint(2)-vec1(1) ; v(1) = rs.lowSkewPoint(1) - vec1(2); 
u(2) = rs.lowSkewPoint(2)+vec2(1) ; v(2) = rs.lowSkewPoint(1) + vec2(2); 
u(3) = rs.upSkewPoint(2)+vec2(1) ; v(3) = rs.upSkewPoint(1) + vec2(2); 
u(4) = rs.upSkewPoint(2)-vec1(1) ; v(4) = rs.upSkewPoint(1) - vec1(2); 

n=[cos(lpRegions.alpha), -sin(lpRegions.alpha)]; nNorm = n/norm(n);
%u(1) = xLeft - n(1)/n(2)*reserv; v(1) = yMinGlob + n(2)/n(1)*(xMinGlob-xLeft + reserv);% + nNorm(2)*reserv; 
%u(2) = xRight + nNorm(1)*reserv; v(2) = yMinGlob - n(2)/n(1)*(xRight-xMinGlob - reserv);% + nNorm(2)*reserv; ; 
%u(3) = xRight + nNorm(1)*reserv; v(3) = yMaxGlob - n(2)/n(1)*(xRight-xMaxGlob - reserv);% - nNorm(2)*reserv; ; 
%u(4) = xLeft - nNorm(1)*reserv; v(4) = yMaxGlob + n(2)/n(1)*(xMaxGlob-xLeft + reserv);% - nNorm(2)*reserv; ; 

u(1) = xLeft - nNorm(1)*reserv; v(1) = yMinGlob + n(2)/n(1)*(xMinGlob-xLeft) + nNorm(2)*reserv - yreserv; 
u(2) = xRight + nNorm(1)*reserv; v(2) = yMinGlob - n(2)/n(1)*(xRight-xMinGlob) - nNorm(2)*reserv - yreserv; 
u(3) = xRight + nNorm(1)*reserv; v(3) = yMaxGlob - n(2)/n(1)*(xRight-xMaxGlob) - nNorm(2)*reserv + yreserv;  
u(4) = xLeft - nNorm(1)*reserv; v(4) = yMaxGlob + n(2)/n(1)*(xMaxGlob-xLeft) + nNorm(2)*reserv + yreserv ; 


% plot(u(:), -v(:), '*');

outRect = [u',v'];
